# ImageDistances.jl

[![][travis-img]][travis-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]

`ImageDistances.jl` aims to:

* follow the same API in [Distances.jl](https://github.com/JuliaStats/Distances.jl)
* support image types
* provide image-specific distances

## Usage

`ImageDistances.jl` is shipped together with `Images.jl`, but you can still use it as a standalone package.

```julia
# both line includes this package
using Images
using ImageDistances
```

Here's a simple usage example

```julia
using ImageDistances, TestImages

d = Euclidean()
imgA = testimage("cameraman") # N0f8
imgB = testimage("lena_gray_512") # N0f8

# distance between two images
evaluate(d, imgA, imgB) # 142.59576f0
d(imgA, imgB) # 142.59576f0
```

Distances are calculated regardless of the color type and storage type.

```julia
using ImageCore

# For gray image, all of them equals
d(imgA, imgB) # 142.59576f0
d(float32.(imgA), float32.(imgB)) # 142.59576f0
d(Float32.(imgA), Float32.(imgB)) # 142.59576f0
d(imgA, float32.(imgB)) # 142.59576f0
```

However, for `Color3` images such as `RGB`, it's noteworthy that the following results are
different in general.

```julia
d = ZNCC()
imgA = testimage("lena_color_512")
imgB = testimage("fabio_color_512")
# distance of each pixel is calculated first, and then sum up all pixels
d(imgA, imgB) # 0.023451565f0
# distance of each slice is calculated first, and then sum up three channels
d(channelview(imgA), channelview(imgB)) # 0.21142173f0
```

That's said, to achieve the same results to other languages, you need to `channelview` the image first to get a raw numeric view.

Just like in `Distances.jl`, huge performance gains are obtained by calling the `colwise` and `pairwise`
functions instead of naively looping over a collection of images and calling `evaluate`.

```julia
d = ModifiedHausdorff()

# two lists of images
imgsA = [imgA, imgB, ...]
imgsB = [imgB, imgA, ...]

# distance between the "columns"
colwise(d, imgsA, imgsB)

# distance between every pair of images
pairwise(d, imgsA, imgsB)
pairwise(d, imgsA)
```

## Distances

### General Distances

| type name               |  convenient syntax         | math definition                   |
| ----------------------- | -------------------------- | --------------------------------- |
|  Euclidean              |  `euclidean(x, y)`         | `sqrt(sum((x - y) .^ 2))`         |
|  SqEuclidean            |  `sqeuclidean(x, y)`       | `sum((x - y).^2)`                 |
|  Cityblock              |  `cityblock(x, y)`         | `sum(abs(x - y))`                 |
|  TotalVariation         |  `totalvariation(x, y)`    | `sum(abs(x - y)) / 2`             |
|  Minkowski              |  `minkowski(x, y, p)`      | `sum(abs(x - y).^p) ^ (1/p)`      |
|  Hamming                |  `hamming(x, y)`           | `sum(x .!= y)`                    |
|  SumAbsoluteDifference  |  `sad(x, y)`               | `sum(abs(x - y))`                 |
|  SumSquaredDifference   |  `ssd(x, y)`               | `sum((x - y).^2)`                 |
|  MeanAbsoluteError      |  `mae(x, y)`, `sadn(x, y)` | `sum(abs(x - y))/len(x)`          |
|  MeanSquaredError       |  `mse(x, y)`, `ssdn(x, y)` | `sum((x - y).^2)/len(x)`          |
|  RootMeanSquaredError   |  `rmse(x, y)`              | `sqrt(sum((x - y) .^ 2)/len(x))`  |
|  ZNCC                    |  `zncc(x, y)`               | `dot(x,y)/(norm(x)*norm(y))`      |

### Image-specific Distances

| Distance type | Convenient syntax | References |
|----------|------------------------|------------|
| `Hausdorff` and `ModifiedHausdorff` | `hausdorff(imgA,imgB)` and `modified_hausdorff(imgA,imgB)` | Dubuisson, M-P et al. 1994. A Modified Hausdorff Distance for Object-Matching. |
| `CIEDE2000` | `ciede2000(imgA,imgB)` and `ciede2000(imgA,imgB; metric=DE_2000())` | Sharma, G., Wu, W., and Dalal, E. N., 2005. The CIEDE2000 color‐difference formula. |


<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageDistances.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[travis-img]: https://travis-ci.org/JuliaImages/ImageDistances.jl.svg?branch=master
[travis-url]: https://travis-ci.org/JuliaImages/ImageDistances.jl
[codecov-img]: https://codecov.io/github/JuliaImages/ImageDistances.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageDistances.jl?branch=master

using Test
using ImageCore
using IterTools
using ReferenceTests
using ImageDistances

# general distances should cover any combination of number_types and color_types unless it's special designed
include("testutils.jl")


include("hausdorff.jl")
include("metrics.jl")
include("ciede2000.jl")

@info "deprecation warnings are expected"
include("deprecated.jl")

nothing

@doc raw"""
    Cityblock <: Metric
    SumAbsoluteDifference <: Metric
    cityblock(x, y)
    sad(x, y)

sum of absolute difference(sad), also known as [`Cityblock`](@ref) distance, is calculated by `sum(abs(x - y))`
"""
struct SumAbsoluteDifference <: Metric end

@doc raw"""
    SqEuclidean <: Metric
    SumSquaredDifference <: Metric
    sqeuclidean(x, y)
    ssd(x, y)

sum of squared difference(ssd), also known as [`SqEuclidean`](@ref) distance, is calculated by `sum(abs2(x - y))`
"""
struct SumSquaredDifference <: Metric end

@doc raw"""
    MeanAbsoluteError <: Metric
    mae(x, y)
    sadn(x, y)

mean absolute error(mae) is calculated by [`sad`](@ref)`(x, y)/length(x)`
"""
struct MeanAbsoluteError <: Metric end

@doc raw"""
    MeanSquaredError <: Metric
    mse(x, y)
    ssdn(x, y)

mean squared error(mse) is calculated by [`ssd`](@ref)`(x, y)/length(x)`
"""
struct MeanSquaredError <: Metric end

@doc raw"""
    ZNCC <: PreMetric
    zncc(x, y)

Zero-mean Normalized Cross-correlation(ZNCC) is calculated by `dot(x,y)/(norm(x)*norm(y))`:

```math
\frac{<\bar{x}, \bar{y}>}{||\bar{x}||*||\bar{y}||}
```

where `x`/`y` are zero-meaned, i.e., `x := x - mean(x)`.

!!! info

    ZNCC isn't a `Metric` because `zncc(x, x) == 1.0`. ZNCC might output `NaN` if any of the input
    array is all-zero.

# References

[1] Nakhmani, Arie, and Allen Tannenbaum. "A new distance measure based on generalized image normalized cross-correlation for robust video tracking and image recognition." _Pattern recognition letters_ 34.3 (2013): 315-321.
"""
struct ZNCC <: PreMetric end

@doc raw"""
    RootMeanSquaredError <: Metric
    rmse(x, y)

Root Mean Square Error(rmse) is calculated by `sqrt(mse(x, y))`
"""
struct RootMeanSquaredError <: Metric end

# SumAbsoluteDifference
(::SumAbsoluteDifference)(a::GenericImage, b::GenericImage) =
    Cityblock()(a, b)

@doc (@doc SumAbsoluteDifference)
sad(a::GenericImage, b::GenericImage) = SumAbsoluteDifference()(a, b)


# SumSquaredDifference
(::SumSquaredDifference)(a::GenericImage, b::GenericImage) =
    SqEuclidean()(a, b)

@doc (@doc SumSquaredDifference)
ssd(a::GenericImage, b::GenericImage) = SumSquaredDifference()(a, b)


# MeanAbsoluteError
(::MeanAbsoluteError)(a::GenericImage, b::GenericImage) =
    SumAbsoluteDifference()(a, b) / length(a)

@doc (@doc MeanAbsoluteError)
mae(a::GenericImage, b::GenericImage) = MeanAbsoluteError()(a, b)
@doc (@doc MeanAbsoluteError)
const sadn = mae


# MeanSquaredError
(::MeanSquaredError)(a::GenericImage, b::GenericImage) =
    SumSquaredDifference()(a, b) / length(a)

@doc (@doc MeanSquaredError)
mse(a::GenericImage, b::GenericImage) = MeanSquaredError()(a, b)
@doc (@doc MeanSquaredError)
const ssdn = mse


# RootMeanSquaredError
(::RootMeanSquaredError)(a::GenericImage, b::GenericImage) =
    sqrt(MeanSquaredError()(a, b))

@doc (@doc RootMeanSquaredError)
rmse(a::GenericImage, b::GenericImage) = RootMeanSquaredError()(a, b)

# ZNCC
function (::ZNCC)(a::GenericGrayImage, b::GenericGrayImage)
    A = channelview(of_eltype(floattype(eltype(a)), a))
    B = channelview(of_eltype(floattype(eltype(b)), b))
    return _zncc(A, B)
end

function (::ZNCC)(a::AbstractArray{<:Color3}, b::AbstractArray{<:Color3})
    A = of_eltype(floattype(eltype(a)), a)
    B = of_eltype(floattype(eltype(b)), b)
    return _zncc(A, B)
end

function _zncc(A::GenericImage, B::GenericImage)
    Am = @view (A.-mean(A))[:]
    Bm = @view (B.-mean(B))[:]
    # _norm is a patch for ColorVectorSpace 0.9
    _dot(Am, Bm)/(_norm(Am)*_norm(Bm))
end

_dot(a::AbstractArray{<:Number}, b::AbstractArray{<:Number}) = dot(a, b)
_dot(a::GenericImage, b::GenericImage) = mapreduce(xy->dotc(xy...), +, zip(a, b))

@doc (@doc ZNCC)
zncc(a::GenericImage, b::GenericImage) = ZNCC()(a, b)

# TODO: broadcasting
function colwise!(r::AbstractVector, dist::PreMetric,
                  a::AbstractVector{<:GenericImage},
                  b::AbstractVector{<:GenericImage})
    n = length(a)
    n == length(b) || throw(DimensionMismatch("The number of columns in a and b must match."))
    length(r) == n || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for j = 1:n
        r[j] = dist(a[j], b[j]) # TODO: use view
    end
    r
end

function colwise!(r::AbstractVector, dist::PreMetric,
                  a::AbstractMatrix{<:GenericImage},
                  b::AbstractMatrix{<:GenericImage})
    (m, n) = get_colwise_dims(size(a, 1), r, a, b)
    m == 1 || throw(DimensionMismatch("The number of columns should be 1."))
    @inbounds for j = 1:n
        r[j] = dist(a[1,j], b[1,j]) # TODO: use view
    end
    r
end

function colwise(dist::PreMetric,
                 a::AbstractVector{<:GenericImage},
                 b::AbstractVector{<:GenericImage})
    n = length(a)
    r = Vector{result_type(dist, a, b)}(undef, n)
    colwise!(r, dist, a, b)
end

function colwise(dist::PreMetric,
                 a::AbstractMatrix{<:GenericImage},
                 b::AbstractMatrix{<:GenericImage})
    n = get_common_ncols(a, b)
    r = Vector{result_type(dist, a, b)}(undef, n)
    colwise!(r, dist, a, b)
end

# Generic pairwise evaluation
# TODO: Matrix support
# TODO: add `pairwise!` and `_pairwise!` to accelerate using codes from `Distances`

function pairwise(d::PreMetric,
                  imgsA::AbstractVector{<:GenericImage},
                  imgsB::AbstractVector{<:GenericImage} = imgsA)
    m, n = length(imgsA), length(imgsB)
    D = zeros(m, n)
    for j = 1:n
        imgB = imgsB[j] # TODO: use view
        for i = 1:m
            imgA = imgsA[i] # TODO: use view
            @inbounds D[i,j] = d(imgA, imgB)
        end
    end

    D
end

# exploit symmetry of semimetric
function pairwise(d::SemiMetric, imgs::AbstractVector{<:GenericImage})
    n = length(imgs)
    D = zeros(n, n)
    for j = 1:n
        imgB = imgs[j] # TODO: use view
        for i = j + 1:n
            imgA = imgs[i] # TODO: use view
            @inbounds D[i,j] = d(imgA, imgB)
        end
        # nothing to be done to the diagonal (always zero)
        for i = 1:j - 1
            @inbounds D[i,j] = D[j,i] # leverage the symmetry
        end
    end

    D
end

# fallback

result_type(dist::PreMetric,
            a::AbstractArray{<:AbstractArray},
            b::AbstractArray{<:AbstractArray}) =
    result_type(dist, a[1], b[1]) # TODO: use view

for (ATa, ATb) in ((AbstractGray, AbstractGray),
                   (AbstractGray, Number),
                   (Number, AbstractGray),
                   (PromoteType, PromoteType),
                   (Color3, Color3))
    @eval function result_type(dist::PreMetric, ::Type{Ta}, ::Type{Tb}) where {Ta <: $ATa,Tb <: $ATb}
        T1 = eltype(floattype(Ta))
        T2 = eltype(floattype(Tb))
        result_type(dist, T1, T2)
    end
end

# Test Metrics from Distances.jl
m, n = 3, 5
sz_img = (3, 3)
sz_img_3 = (3, 3, 3)

dist_list = [SqEuclidean(),
            Euclidean(),
            Cityblock(),
            Minkowski(2),
            Minkowski(2.5),
            Hamming(),
            TotalVariation(),
            ZNCC(),
            SumAbsoluteDifference(),
            SumSquaredDifference(),
            MeanAbsoluteError(),
            MeanSquaredError(),
            RootMeanSquaredError(),
            ]

for dist in dist_list
    @testset "$(typeof(dist))" begin
        @info "test: $(typeof(dist))"
        # Gray image
        type_list = generate_test_types([Bool, Float32, N0f8], [Gray])
        A = [0.0 0.0 0.0; 1.0 1.0 1.0; 0.0 0.0 0.0]
        B = [1.0 1.0 1.0; 0.0 0.0 0.0; 1.0 1.0 1.0]
        for T in type_list
            @testset "$T" begin
                test_colwise(dist, n, sz_img, T)
                test_pairwise(dist, m, n, sz_img, T)
                test_ndarray(dist, sz_img_3, T)

                a = A .|> T
                b = B .|> T
                test_numeric(dist, a, b, T)
                test_numeric(dist, channelview(a), channelview(b), T)
            end
        end
        test_cross_type(dist, A, B, type_list)

        # RGB image
        type_list = generate_test_types([Float32, N0f8], [RGB])
        A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
            RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
            RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
        B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
            RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
            RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
        for T in type_list
            @testset "$T" begin
                test_colwise(dist, n, sz_img, T)
                test_pairwise(dist, m, n, sz_img, T)
                test_ndarray(dist, sz_img_3, T)

                a = A .|> T
                b = B .|> T

                test_numeric(dist, a, b, T)
            end
        end
        test_cross_type(dist, A, B, type_list)
    end
end

module ImageDistances

using Distances, LinearAlgebra, Statistics
using Distances:
    get_common_ncols,
    get_colwise_dims,
    get_pairwise_dims
import Distances:
    result_type,
    colwise,
    colwise!,
    pairwise

using ImageCore
using ImageCore.MappedArrays
using ImageCore: GenericImage, GenericGrayImage, Pixel
import ImageMorphology
using ImageMorphology.FeatureTransform:
    feature_transform,
    distance_transform

# FixedPoint and Bool are promoted to Float before evaluate
const PromoteType = Union{FixedPoint,Bool}

include("generic.jl")
include("metrics_distances.jl")
include("metrics.jl")
include("hausdorff.jl")
include("ciede2000.jl")
include("compat.jl")
include("deprecated.jl")

for MT in [GenericHausdorff, SumAbsoluteDifference, SumSquaredDifference, ZNCC, RootMeanSquaredError, MeanAbsoluteError, MeanSquaredError, CIEDE2000]
    @eval Distances.result_type(::$MT, a::Type{T}, ::Type{U}) where {T<:AbstractFloat,U<:AbstractFloat} = promote_type(T, U)
end


# reexport symbols from Distances.jl
# delibrately not use Reexport
# untested metrics from Distances are not exported
export
    # generic types
    PreMetric,
    SemiMetric,
    Metric,

    # generic functions
    result_type,
    evaluate,
    colwise,
    colwise!,
    pairwise,

    # concrete types
    SqEuclidean,
    Euclidean,
    Cityblock,
    Minkowski,
    Hamming,
    TotalVariation,

    # helper functions
    sqeuclidean,
    euclidean,
    cityblock,
    minkowski,
    hamming,
    totalvariation

export
    # concrete types
    GenericHausdorff,
    Hausdorff,
    ModifiedHausdorff,
    AxisWeightedHausdorff,
    CIEDE2000,
    SumAbsoluteDifference,
    SumSquaredDifference,
    MeanAbsoluteError,
    MeanSquaredError,
    RootMeanSquaredError,
    ZNCC,

    # helper functions
    hausdorff,
    modified_hausdorff,
    ciede2000,
    sad,
    ssd,
    mae,
    sadn,
    mse,
    ssdn,
    rmse,
    zncc

"""
`ImageDistances` is an image-related distance package built based on `Distances`.
"""
ImageDistances
end # module

A = [true false false
     false true false
     false false true]
B = copy(A); B[1,2] = true;
sz_img = (3,3)
sz_img_3 = (3, 3, 3)
m, n = 3, 5

type_list = generate_test_types([Bool], [Gray])

@testset "GenericHausdorff" begin
    @info "test: GenericHausdorff"

    dist = Hausdorff()
    A_zero = zeros(Bool, 3, 3)
    @testset "Hausdorff" begin
        for T in type_list
            @testset "$T" begin
                test_Metric(dist, sz_img, T)
                test_ndarray(dist, sz_img_3, T)
                test_colwise(dist, n, sz_img, T)
                test_pairwise(dist, m, n, sz_img, T)

                a = A .|> T
                b = B .|> T
                test_numeric(dist, a, b, T; filename="references/Hausdorff_2d_Gray")
            end
        end
        @test dist(A_zero, A_zero) == 0.0
        @test dist(A_zero, A) == Inf
        @test dist(A, A_zero) == Inf
    end
    test_cross_type(dist, A, B, type_list)

    dist = ModifiedHausdorff()
    @testset "ModifiedHausdorff" begin
        for T in type_list
            @testset "$T" begin
                test_SemiMetric(dist, sz_img, T)
                test_ndarray(dist, sz_img_3, T)
                test_colwise(dist, n, sz_img, T)
                test_pairwise(dist, m, n, sz_img, T)

                a = A .|> T
                b = B .|> T
                test_numeric(dist, a, b, T; filename="references/ModifiedHausdorff_2d_Gray")
            end
        end
    end
    test_cross_type(dist, A, B, type_list)

    dist_2 = AxisWeightedHausdorff((1.0, 1.5))
    dist_3 = AxisWeightedHausdorff((1.0, 1.5, 2.0))
    @testset "AxisWeightedHausdorff" begin
        Aw = [false false false
            false true false
            false false true]
        Bw = [false true false
            false true false
            false false true]
        Cw = [false false false
            true true false
            false false true]
        @test dist_2(Aw, Bw) == 1.0
        @test dist_2(Aw, Cw) == 1.5
        
        for T in type_list
            @testset "$T" begin
                test_SemiMetric(dist_2, sz_img, T)
                test_ndarray(dist_3, sz_img_3, T)
                test_colwise(dist_2, n, sz_img, T)
                test_pairwise(dist_2, m, n, sz_img, T)
            end
        end
    end
    test_cross_type(dist_2, A, B, type_list)
end

"""
    ReductionOperation

A reduction operation on a set of values (e.g. maximum).
"""
abstract type ReductionOperation end

struct MaxReduction  <: ReductionOperation end
struct MeanReduction <: ReductionOperation end

_reduce(op::MaxReduction, x)  = maximum(x)
_reduce(op::MeanReduction, x) = sum(x) / length(x)

"""
    GenericHausdorff(inner_op, outer_op, weights = nothing)

The generalized Hausdorff distance with inner reduction `inner_op`
and outer reduction `outer_op`. Optionally, `weights` can be used for each axis
before distance transformations are applied.

## References

Dubuisson, M-P; Jain, A. K., 1994. *A Modified Hausdorff Distance for Object-Matching*.

See also: [`Hausdorff`](@ref), [`ModifiedHausdorff`](@ref)
"""
struct GenericHausdorff{I<:ReductionOperation, O<:ReductionOperation, W<:Union{Nothing,Tuple}} <: Metric
    inner_op::I
    outer_op::O
    weights::W
end

@doc raw"""
    Hausdorff <: GenericHausdorff
    hausdorff(x::BoolImage, y::BoolImage)

Hausdorff distance between two point sets ``\mathcal{A}`` and ``\mathcal{B}``, which
consist of point positions of 1s of `x` and `y`, respectively. The distance is computed
using the following formula:

```math
    \text{hausdorff}(x,y) = max(d(\mathcal{A}, \mathcal{B}), d(\mathcal{B}, \mathcal{A}))
```
where
```math
    d(\mathcal{A}, \mathcal{B}) = max_{a\in\mathcal{A}}d(a, \mathcal{B}) \\
    d(a, \mathcal{B}) = max_{b\in\mathcal{B}}d(a, b)
```
and the point distance is calcuated using [`Euclidean`](@ref) distance.

## References

Dubuisson, M-P; Jain, A. K., 1994. *A Modified Hausdorff Distance for Object-Matching*.

See also: [`modified_hausdorff`](@ref)
"""
const Hausdorff = GenericHausdorff{MaxReduction, MaxReduction, Nothing}
Hausdorff() = Hausdorff(MaxReduction(), MaxReduction(), nothing)

@doc raw"""
    ModifiedHausdorff <: GenericHausdorff
    modified_hausdorff(x::BoolImage, y::BoolImage)

Modified Hausdorff distance between two point sets ``\mathcal{A}`` and ``\mathcal{B}``,
which consist of point positions of 1s of `x` and `y`, respectively. The distance is
computed using the following formula:

```math
    \text{modified_hausdorff}(x,y) = max(d(\mathcal{A}, \mathcal{B}), d(\mathcal{B}, \mathcal{A}))
```
where
```math
    d(\mathcal{A}, \mathcal{B}) = \frac{1}{N_a}\sum_{a\in\mathcal{A}}d(a, \mathcal{B}) \\
    d(a, \mathcal{B}) = max_{b\in\mathcal{B}}d(a, b)
```
and the point distance is calcuated using [`Euclidean`](@ref) distance.

## References

Dubuisson, M-P; Jain, A. K., 1994. *A Modified Hausdorff Distance for Object-Matching*.

See also: [`hausdorff`](@ref)
"""
const ModifiedHausdorff = GenericHausdorff{MeanReduction, MaxReduction, Nothing}
ModifiedHausdorff() = ModifiedHausdorff(MeanReduction(), MaxReduction(), nothing)

"""
    AxisWeightedHausdorff(weights::Tuple)

Hausdorff distance (see `Hausdorff` for general documentation) where axes are weighted
using specified weights. Distances (expressed as differences between indices in
successive axes) are multiplied by given weights.
"""
AxisWeightedHausdorff(weights::Tuple) = GenericHausdorff(MaxReduction(), MaxReduction(), weights)

# convert binary image to its distance transform
function hausdorff_transform(d::GenericHausdorff, img::AbstractArray{Bool})
    return distance_transform(_feature_transform(img, d.weights), d.weights)
end
function hausdorff_transform(d::GenericHausdorff, img::GenericGrayImage)
  try
      hausdorff_transform(d, of_eltype(Bool, img))
  catch e
      e isa InexactError && throw(ArgumentError("Binary image is needed."))
      rethrow(e)
  end
end

function evaluate_hausdorff(d::GenericHausdorff,
                            imgA::AbstractArray{Bool},
                            imgB::AbstractArray{Bool},
                            dtA::AbstractArray,
                            dtB::AbstractArray)
    # trivial cases
    T = result_type(d, dtA, dtB)
    imgA == imgB && return zero(T)
    (!any(imgA) || !any(imgB)) && return convert(T, Inf)

    # dtA and dtB contain the distance from each pixel
    # to the nearest active pixel in imgA and imgB, respectively.
    # We only care about the distances from imgA to imgB and vice
    # versa, so we'll pull those out by using those images as logical
    # masks into the distance arrays.
    dAB = _reduce(d.inner_op, view(dtB, imgA))
    dBA = _reduce(d.inner_op, view(dtA, imgB))
    _reduce(d.outer_op, (dAB, dBA))
end
function evaluate_hausdorff(d::GenericHausdorff,
                            imgA::GenericGrayImage,
                            imgB::GenericGrayImage,
                            dtA::AbstractArray,
                            dtB::AbstractArray)
    try
        evaluate_hausdorff(d, of_eltype(Bool, imgA), of_eltype(Bool, imgB), dtA, dtB)
    catch e
        e isa InexactError && throw(ArgumentError("Binary image is needed."))
        rethrow(e)
    end
end

(d::GenericHausdorff)(imgA::GenericGrayImage, imgB::GenericGrayImage) =
    evaluate_hausdorff(d, imgA, imgB, hausdorff_transform(d, imgA), hausdorff_transform(d, imgB))

# helper functions
@doc (@doc Hausdorff)
hausdorff(imgA::GenericGrayImage, imgB::GenericGrayImage) =
    Hausdorff()(imgA, imgB)

@doc (@doc ModifiedHausdorff)
modified_hausdorff(imgA::GenericGrayImage, imgB::GenericGrayImage)  =
    ModifiedHausdorff()(imgA, imgB)

# precalculate distance transforms to accelerate computing
function pairwise(d::GenericHausdorff,
                  imgsA::AbstractVector{<:GenericGrayImage},
                  imgsB::AbstractVector{<:GenericGrayImage})
    dtsA = hausdorff_transform.(Ref(d), imgsA)
    dtsB = hausdorff_transform.(Ref(d), imgsB)

    m, n = length(imgsA), length(imgsB)
    D = zeros(m, n)

    for j=1:n
      imgB = imgsB[j]
      dtB = dtsB[j]
      for i=min(m, j+1):m
        imgA = imgsA[i]
        dtA = dtsA[i]
        D[i,j] = evaluate_hausdorff(d, imgA, imgB, dtA, dtB)
      end
      for i=1:min(m, j+1)
        imgA = imgsA[i]
        dtA = dtsA[i]
        D[i,j] = evaluate_hausdorff(d, imgA, imgB, dtA, dtB)
      end
    end

    D
end

function pairwise(d::GenericHausdorff, imgs::AbstractVector{<:GenericGrayImage})
    dts = hausdorff_transform.(Ref(d), imgs)

    n = length(imgs)
    D = zeros(n, n)
    for j=1:n
      imgB = imgs[j]
      dtB = dts[j]
      for i=j+1:n
        imgA = imgs[i]
        dtA = dts[i]
        D[i,j] = evaluate_hausdorff(d, imgA, imgB, dtA, dtB)
      end
      # nothing to be done to the diagonal (always zero)
      for i=1:j-1
        D[i,j] = D[j,i] # leverage the symmetry
      end
    end

    D
end

# helper function to compare NaN
nearlysame(x, y) = x ≈ y || (isnan(x) & isnan(y))
nearlysame(A::AbstractArray, B::AbstractArray) = all(map(nearlysame, A, B))

# AbstractGray and Color3 tests should be generated seperately
function generate_test_types(number_types::AbstractArray{<:DataType}, color_types::AbstractArray{<:UnionAll})
    test_types = map(Iterators.product(number_types, color_types)) do T
        try
            T[2]{T[1]}
        catch err
            !isa(err, TypeError) && rethrow(err)
        end
    end
    test_types = filter(x->x != false, test_types)
    if isempty(filter(x->x<:Color3, test_types))
        test_types = [number_types..., test_types...]
    end
    test_types
end

"""
    test_colwise(dist, n, sz, T)

test if `colwise` works as expected in the following two inputs:

* `(n,)Vector` - `(n,)Vector`
* `(1,n)Matrix` - `(1,n)Matrix`

and throw error for ambigious inputs:

* `(m,n)Matrix` - `(m,b)Matrix`  where `m!=1`

"""
function test_colwise(dist, n, sz, T)
    @testset "colwise" begin
        vec_imgsA = [rand(T, sz) for _ in 1:n]
        vec_imgsB = [rand(T, sz) for _ in 1:n]
        mat_imgsA = reshape(vec_imgsA, (1, n))
        mat_imgsB = reshape(vec_imgsB, (1, n))
        mat_imgsA_wrong = reshape(vec_imgsA, (n, 1))
        mat_imgsB_wrong = reshape(vec_imgsB, (n, 1))

        RT = result_type(dist, vec_imgsA, vec_imgsB)
        r1 = zeros(RT, n)
        r2 = zeros(RT, n)
        for j = 1:n
            r1[j] = dist(vec_imgsA[j], vec_imgsB[j])
            r2[j] = dist(mat_imgsA[1,j], mat_imgsB[1,j])
        end
        @test nearlysame(colwise(dist, vec_imgsA, vec_imgsB), r1)
        @test nearlysame(colwise(dist, mat_imgsA, mat_imgsB), r2)
        @test_throws DimensionMismatch colwise(dist, mat_imgsA_wrong, mat_imgsB_wrong)
    end
end

"""
    test_pairwise(dist, nA, nB, sz, T)

test if `pairwise` works as expected in the following two inputs:

* `(n,)Vector`-`(n,)Vector`
"""
function test_pairwise(dist, nA, nB, sz, T)
    @testset "pairwise" begin
        vec_imgsA = [rand(T, sz) for _ in 1:nA]
        vec_imgsB = [rand(T, sz) for _ in 1:nB]

        RT = result_type(dist, vec_imgsA, vec_imgsB)
        rAB = zeros(RT, nA, nB)
        rAA = zeros(RT, nA, nA)
        for j = 1:nB, i = 1:nA
            rAB[i, j] = dist(vec_imgsA[i], vec_imgsB[j])
        end
        for j = 1:nA, i = 1:nA
            rAA[i, j] = dist(vec_imgsA[i], vec_imgsA[j])
        end
        @test nearlysame(pairwise(dist, vec_imgsA, vec_imgsB), rAB)
        @test nearlysame(pairwise(dist, vec_imgsA, vec_imgsA), rAA)
        @test nearlysame(pairwise(dist, vec_imgsA), rAA)
    end
end

_base_colorant_type(::Type{<:Number}) = Gray
_base_colorant_type(::Type{T}) where T<:Colorant = base_colorant_type(T)
"""
    test_numeric(dist, a, b, T; filename=nothing)

simply test that `dist` works for 2d image as expected, more tests go to `Distances.jl`
"""
function test_numeric(dist, a, b, T; filename=nothing)
    size(a) == size(b) || error("a and b should be the same size")
    if filename == nothing
        filename = "references/$(typeof(dist))_$(ndims(a))d"

        if eltype(a) <: Color3
            filename = filename * "_$(_base_colorant_type(T))"
        elseif eltype(a) <: Union{Number, AbstractGray}
            filename = filename * "_$(_base_colorant_type(T))"
        end
    end
    @testset "numeric" begin
        @testset "$T" begin
            @test_reference "$(filename).txt" Float64(dist(a, b)) by=(x,y)->isapprox(x,y; atol=1e-8)
        end
    end
end

"""
    test_cross_type(dist, a, b, type_list)

simply test if operations between `N0f8`, `Bool` and `Float32` types works as expected.
`a` and `b` should be simple enough to get rid of InexactError.
"""
function test_cross_type(dist, a, b, type_list)
    size(a) == size(b) || error("a and b should be the same size")
    rsts = [[dist(Ta.(a), Tb.(b)),
             dist(Tb.(a), Ta.(b))] for (Ta, Tb) in subsets(type_list, 2)]
    rsts = hcat(rsts...)
    @test all(isapprox.(rsts, rsts[1]; rtol=1e-5))
end

function test_Metric(d, sz, T)
    x = rand(T, sz)
    y = rand(T, sz)
    z = rand(T, sz)
    @test d(x, y) >= 0
    @test d(x, x) ≈ 0
    @test d(x, y) ≈ d(y, x)
    @test d(x, y) + d(y, z) >= d(x, z)
end

function test_SemiMetric(d, sz, T)
    x = rand(T, sz)
    y = rand(T, sz)
    z = rand(T, sz)
    @test d(x, y) >= 0
    @test d(x, x) ≈ 0
    @test d(x, y) ≈ d(y, x)
end

function test_ndarray(d, sz, T)
    x = rand(T, sz)
    y = rand(T, sz)
    @test_nowarn d(x, y)

    T <: AbstractGray || return nothing
    @test d(x, y) ≈ d(channelview(x), channelview(y))
end

using BenchmarkTools
using ImageDistances
using Distances
using TestImages
using ImageBinarization

const SUITE = BenchmarkGroup()

on_CI = haskey(ENV, "GITHUB_ACTIONS")

function create_distances()
    dists = [
        SqEuclidean(),
        Euclidean(),
        Cityblock(),
        TotalVariation(),
        Minkowski(2),
        Hamming(),
        SumAbsoluteDifference(),
        SumSquaredDifference(),
        MeanAbsoluteError(),
        MeanSquaredError(),
        RootMeanSquaredError(),
        ZNCC(),
        Hausdorff(),
        ModifiedHausdorff(),
        CIEDE2000(),
    ]
    return dists
end

#############
# Distances #
############

SUITE["distances"] = BenchmarkGroup()

function add_distances_benchmarks!(SUITE)

    imgA = testimage("cameraman")
    imgB = testimage("livingroom")

    alg = Otsu()
    imgA = binarize(imgA, alg)
    imgB = binarize(imgA, alg)

    imgC = Float32.(imgA)
    imgD = Float32.(imgB)

    dists = create_distances()

    for dist in (dists)
        Tdist = typeof(dist)
        SUITE["distances"][Tdist] = BenchmarkGroup()
        SUITE["distances"][Tdist]["ImageDistances.jl"] =
            @benchmarkable evaluate($dist, $imgA, $imgB)
        SUITE["distances"][Tdist]["Distances.jl"] =
            @benchmarkable Distances.evaluate($dist, $imgC, $imgD)
    end
end

add_distances_benchmarks!(SUITE)

###########
# Colwise #
###########

SUITE["colwise"] = BenchmarkGroup()

function add_colwise_benchmarks!(SUITE)

    imgA = testimage("cameraman")
    imgB = testimage("livingroom")

    alg = Otsu()
    imgA = binarize(imgA, alg)
    imgB = binarize(imgA, alg)

    imgC = Float32.(imgA)
    imgD = Float32.(imgB)

    # Two lists of images
    imgsA = [imgA, imgB, imgA, imgB]
    imgsB = [imgB, imgA, imgA, imgB]

    imgsC = [imgC, imgD, imgC, imgD]
    imgsD = [imgD, imgC, imgC, imgD]

    dists = create_distances()

    for dist in (dists)
        Tdist = typeof(dist)
        SUITE["colwise"][Tdist] = BenchmarkGroup()
        SUITE["colwise"][Tdist]["ImageDistances.jl"] =
            @benchmarkable colwise($dist, $imgsA, $imgsB)
        SUITE["colwise"][Tdist]["Distances.jl"] =
            @benchmarkable Distances.colwise($dist, $imgsC, $imgsD)
    end
end

add_colwise_benchmarks!(SUITE)

############
# Pairwise #
############

SUITE["pairwise"] = BenchmarkGroup()

function add_pairwise_benchmarks!(SUITE)

    imgA = testimage("cameraman")
    imgB = testimage("livingroom")

    alg = Otsu()
    imgA = binarize(imgA, alg)
    imgB = binarize(imgA, alg)

    imgC = Float32.(imgA)
    imgD = Float32.(imgB)

    # Two lists of images
    imgsA = [imgA, imgB, imgA, imgB]
    imgsB = [imgB, imgA, imgA, imgB]

    imgsC = [imgC, imgD, imgC, imgD]
    imgsD = [imgD, imgC, imgC, imgD]
    dists = create_distances()

    for dist in (dists)
        Tdist = typeof(dist)
        SUITE["pairwise"][Tdist] = BenchmarkGroup()
        SUITE["pairwise"][Tdist]["ImageDistances.jl"] =
            @benchmarkable pairwise($dist, $imgsA, $imgsB)
        SUITE["pairwise"][Tdist]["Distances.jl"] =
            @benchmarkable Distances.pairwise($dist, $imgsC, $imgsD)
    end
end

add_pairwise_benchmarks!(SUITE)

const ColorMetric = Colors.DifferenceMetric

"""
    CIEDE2000 <: SemiMetric
    ciede2000(x, y; metric=DE_2000())

The pixel-wise `CIEDE2000` color-difference between image `a` and `b`.
Optionally, a metric may be supplied, chosen among `DE_2000` (the default), `DE_94`,
`DE_JPC79`, `DE_CMC`, `DE_BFD`, `DE_AB`, `DE_DIN99`, `DE_DIN99d`, `DE_DIN99o`.

## References

Sharma, G., Wu, W., and Dalal, E. N., 2005. *The CIEDE2000 color‐difference formula*.
"""
struct CIEDE2000{M<:ColorMetric} <: SemiMetric
    metric::M
end

CIEDE2000() = CIEDE2000(DE_2000())

# colordiff converts image to Lab space, so we don't promote the storage type here
function (d::CIEDE2000)(imgA::GenericImage, imgB::GenericImage)
    sum(abs, colordiff.(imgA, imgB; metric=d.metric))
end

# helper function
@doc (@doc CIEDE2000)
ciede2000(imgA::GenericImage, imgB::GenericImage; metric=DE_2000()) =
    CIEDE2000(metric)(imgA, imgB)

# patch for ColorVectorSpace 0.9
# for CVS < 0.9, we can just use the fallback solution in Distances
if isdefined(ImageCore.ColorVectorSpace, :⊙)
    # Because how abs2 calculated in color vector space is ambiguious, abs2(::RGB) is un-defined
    # since ColorVectorSpace 0.9
    # https://github.com/JuliaGraphics/ColorVectorSpace.jl/pull/131
    @inline _abs2(c::AbstractRGB) = red(c)^2+green(c)^2+blue(c)^2
    @inline _abs2(c::AbstractRGB{<:Normed}) = _abs2(float32(c))
    @inline _abs(c::AbstractRGB) = abs(red(c))+abs(green(c))+abs(blue(c))

    @inline Distances.eval_op(::Euclidean, ai::AbstractRGB, bi::AbstractRGB) = _abs2(ai - bi)
    @inline Distances.eval_op(::SqEuclidean, ai::AbstractRGB, bi::AbstractRGB) = _abs2(ai - bi)
    @inline Distances.eval_op(::Cityblock, ai::AbstractRGB, bi::AbstractRGB) = _abs(ai - bi)
    @inline Distances.eval_op(d::Minkowski, ai::AbstractRGB, bi::AbstractRGB) = _abs(ai - bi)^d.p
    @inline Distances.eval_op(::Hamming, ai::AbstractRGB, bi::AbstractRGB) = ai != bi ? 1 : 0
    @inline Distances.eval_op(::TotalVariation, ai::AbstractRGB, bi::AbstractRGB) = _abs(ai - bi)

    # The result can differ from CSV 0.8 because of the computational order
    _norm(X::AbstractArray{<:AbstractRGB}) = sqrt(_abs(sum(x->x⊙x, X)))
    _norm(X::AbstractArray) = norm(X)
else
    _norm(X::AbstractArray) = norm(X)
end

# depwarn fix for ImageMorphology v0.3
# https://github.com/JuliaImages/ImageMorphology.jl/pull/47
if isdefined(ImageMorphology, :SplitAxis)
    _feature_transform(img, weights; kwargs...) = feature_transform(img; weights=weights, kwargs...)
else
    const _feature_transform = feature_transform
end

@testset "CIEDE2000" begin
    @info "test: CIEDE2000"
    dist = CIEDE2000()

    sz_img = (3,3)
    sz_img_3 = (3, 3, 3)
    m, n = 3, 5

    type_list = generate_test_types([Bool, Float32, N0f8], [Gray])
    A = [0 0 0; 1 1 1; 0 0 0]
    B = [1 1 1; 0 0 0; 1 1 1]
    for T in type_list
        @testset "$T" begin
            test_SemiMetric(dist, sz_img, T)
            test_ndarray(dist, sz_img_3, T)
            test_colwise(dist, n, sz_img, T)
            test_pairwise(dist, m, n, sz_img, T)

            a = A .|> T
            b = B .|> T
            test_numeric(dist, a, b, T; filename="references/CIEDE2000_2d_$(_base_colorant_type(T))")
            test_numeric(dist, channelview(a), channelview(b), T; filename="references/CIEDE2000_2d_$(_base_colorant_type(T))")
        end
    end
    test_cross_type(dist, A, B, type_list)

    type_list = generate_test_types([N0f8, Float32], [Lab, RGB])
    A = [RGB(0.0, 0.0, 0.0) RGB(0.0, 1.0, 0.0) RGB(0.0, 1.0, 1.0)
        RGB(0.0, 0.0, 1.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 1.0, 0.0)
        RGB(1.0, 1.0, 1.0) RGB(1.0, 0.0, 1.0) RGB(0.0, 0.0, 0.0)]
    B = [RGB(0.0, 0.0, 0.0) RGB(0.0, 0.0, 1.0) RGB(1.0, 1.0, 1.0)
        RGB(0.0, 1.0, 0.0) RGB(1.0, 0.0, 0.0) RGB(1.0, 0.0, 1.0)
        RGB(0.0, 1.0, 1.0) RGB(1.0, 1.0, 0.0) RGB(0.0, 0.0, 0.0)]
    for T in type_list
        a = A .|> T
        b = B .|> T
        test_ndarray(dist, sz_img_3, T)
        test_numeric(dist, a, b, T; filename="references/CIEDE2000_2d_Color3")
    end
    test_cross_type(dist, A, B, type_list)
end

# patches to metrics.jl of Distances.jl

const metrics = (SqEuclidean, Euclidean, Cityblock, Minkowski, Hamming, TotalVariation)
const UnionMetrics = Distances.UnionMetrics

# Before evaluation, unwrap the AbstractGray colorant and promote storage type
#
# (Gray{N0f8}, Gray{N0f8}) -> (Float32, Float32)
# (Gray{N0f8}, N0f8      ) -> (Float32, Float32)
# (N0f8      , Gray{N0f8}) -> (Float32, Float32)
# (N0f8      , N0f8      ) -> (Float32, Float32)
#
# For AbstractRGB, only promote storage type; basic operation such as `abs2`
# returns a `Number` for `AbstractRGB`(e.g., `RGB`)
#
# (RGB{N0f8}, RGB{N0f8}) -> (RGB{Float32}, RGB{Float32} )
#
# we don't extend `evaluate` here because it makes the dispatching rules too complicated
# we only need to extend `eval_op`, since other operations
# (e.g., `eval_start`, `eval_reduce`, and `eval_end`) will automatically get promoted
for M in metrics
    for (Ta, Tb) in ((AbstractGray, AbstractGray),
                     (AbstractGray, Number),
                     (Number, AbstractGray),
                     (PromoteType, PromoteType))
        @eval function Distances.eval_op(d::$M, a::$Ta, b::$Tb)
            T1 = eltype(floattype(typeof(a)))
            T2 = eltype(floattype(typeof(a)))
            Distances.eval_op(d, T1(a), T2(b))
        end
    end
    @eval function Distances.eval_op(d::$M,
                                     a::AbstractRGB{<:PromoteType},
                                     b::AbstractRGB{<:PromoteType})
        CT1 = floattype(typeof(a))
        CT2 = floattype(typeof(b))
        Distances.eval_op(d, CT1(a), CT2(b))
    end
end

# ambiguities
for (ATa, ATb) in ((AbstractGray, AbstractGray),
                   (AbstractGray, Number),
                   (Number, AbstractGray),
                   (PromoteType, PromoteType),
                   (Color3, Color3))
    @eval function result_type(dist::UnionMetrics, ::Type{Ta}, ::Type{Tb}) where {Ta <: $ATa,Tb <: $ATb}
        T1 = eltype(floattype(Ta))
        T2 = eltype(floattype(Tb))
        result_type(dist, T1, T2)
    end
end
result_type(::Hamming, ::Type{Bool}, ::Type{Bool}) = Int
result_type(::Hamming, ::Type{Normed{UInt8,8}}, ::Type{Normed{UInt8,8}}) = Float32
